# =================================================

# White Tiger WWW Board Enhance ver.1.1b
# (C) 1998-2000, White Tiger (2:5049/138; 
# email:wtiger@mail.ru; http://wtiger.ncport.ru)
# wtbext2.cgi -    
# wtbext2.cgi - internal subroutines extended module

# -------------------------------------------------
# sendwtmail	- mailer
# addbanner		- banner addition
# savebanner	- banner statistics saving
# saveerror		- error logging
# -------------------------------------------------

# =================================================



# sendwtmail(html,toaddress,toname,fromaddress,fromname,subject,body)
# 0 -    ,  wtmaillog.txt  ,
# 1 -  

#  $inip{'wtmail_prog'}:
# -1 -     
# 0 -  
# 1 -   sendmail
# 2 -   mail
sub sendwtmail
{
	my(@a)=@_;my(@s);
	my$version='WTMail v.0.4';

	$wtmailcontenttype||='text/html';
	for($a[5],$a[4],$a[2]){s/\&\#151;/\-/g;s/\&\#(\d+?);/chr($1)/eg;}

	$i=0;my$text=$a[6];
	while($text=~s/((?:.{80,}?\s)|(.*\n))//m){$s[$i]="$1";chomp$s[$i];++$i;}
	$s[$i]="$text";
	$text=join("\n",@s);

	if($inip{'wtmail_prog'}==(-1))
# save to file (test)
	{
		($user,$domain)=split(/\@/,$a[1]);
		$a[2]=~s/\<\>//g;
		$a[4]=~s/<>//g;

		open MAIL,">>$data/wtmailx_$wtboard";
		printf MAIL ("\n==== %2.2d/%2.2d/%4.4d  %2.2d:%2.2d:%2.2d %s",$t[3],$t[4]+1,$t[5],$t[2],$t[1],$t[0],'='x44),"\n";
		print MAIL "\nTo: $a[2] <$user\@$domain>\n";
		if(length$a[3])
		{	print MAIL "From: $a[4] <$a[3]>\n";
			print MAIL "Reply-To: $a[4] <$a[3]>\n";
		}
		print MAIL "Subject: $a[5]\n";
		print MAIL "Content-Type: $wtmailcontenttype; charset=windows-1251\n";
		print MAIL "Content-Transfer-Encoding: 8bit\n";
		print MAIL "X-Mailer: $version\n";
		print MAIL "\n";
		print MAIL "$text\n";
		close MAIL;
	}
	elsif($inip{'wtmail_prog'}==0)
# internal
	{
###########################################
###   ###
########created by Michail Lekarkin########
###########################################
		require 5.005;
		require IO::Socket::INET;
#		use IO::Socket::INET;
		my$socket=IO::Socket::INET->new(PeerAddr=>"localhost",PeerPort=>"25",Proto=>"tcp",Type=>SOCK_STREAM);
		my$answer=<$socket>;if($answer=~/^220/){print $socket "HELO\n"}else{return 0}
		$answer=<$socket>;if($answer=~/^250/){print $socket "mail from:<$a[3]>\n"}else{return 0}
		$answer=<$socket>;if($answer=~/^250/){print$socket "rcpt to:<$a[1]>\n"}else{return 0}
		$answer=<$socket>;if($answer=~/^250/){print $socket "DATA\n"}else{return 0}
		$answer=<$socket>;
		if($answer=~/^354/)
		{	print $socket "To: $a[2] <$a[1]>\n";
			if(length$a[2])
			{	print $socket "From: $a[4] <$a[3]>\n";
				print $socket "Reply-To: $a[4] <$a[3]>\n";
			}
			print $socket "Subject: $a[5]\n";
			print $socket "Content-Type: $wtmailcontenttype; charset=windows-1251\n";
			print $socket "Content-Transfer-Encoding: 8bit\n";
			print $socket "X-Mailer: $version\n\n";
			print $socket "$text\n.\n";
		}
		else{return 0}
		$answer=<$socket>;if($answer=~/^250/){print $socket "quit\n"}else{return 0}
		close ($socket);

	}
	elsif($inip{'wtmail_prog'}==1)
# sendmail
	{	if(!length$inip{'wtmail_client'}){$inip{'wtmail_client'}=`which sendmail`;chomp$inip{'wtmail_client'}}
		if($inip{'wtmail_client'}=~/not/){return 0}
		open(MAIL,"|$inip{wtmail_client} -t");

		print MAIL "To: $a[2] <$a[1]>\n";
		if(length$a[2])
		{	print MAIL "From: $a[4] <$a[3]>\n";
			print MAIL "Reply-To: $a[4] <$a[3]>\n";
		}
		print MAIL "Subject: $a[5]\n";
		print MAIL "Content-Type: $wtmailcontenttype; charset=windows-1251\n";
		print MAIL "Content-Transfer-Encoding: 8bit\n";
		print MAIL "X-Mailer: $version\n";
		print MAIL "\n";

		print MAIL "$text\n";
		close MAIL;
	}
	elsif($inip{'wtmail_prog'}==2)
# mail
	{
		if(!length$inip{'wtmail_client'}){$inip{'wtmail_client'}=`which mail`;chomp$inip{'wtmail_client'}}
		if($inip{'wtmail_client'}=~/not/){return 0}
		open(MAIL,"|$inip{wtmail_client} -s \"$a[5]\" \"$a[2] <$a[1]>\"");
		print MAIL "$text\n\n";
		close MAIL;
	}
	return 1;
}





##     , $banner_id - 
##     savebanner
sub addbanner
{	if($inip{'wtmail_banner'} ne 'on'){return}
	dbmopen%wtmbanner,"$data/$inip{wtmail_bannerfile}",0644;
	$banner_id=0;
#   
	my@a=sort keys%wtmbanner;@s=();
	my$a=0;for(@a)
	{	if(!/^bid_(.*)/){next}
		if(/^e/){last}
		$s=$1;
#   
		if($wtmbanner{"hd_$s"}>$curtime || $wtmbanner{"ed_$s"}<$curtime){next}
#    
		$t=($t[2]*60+$t[1])*60+$t[0];
		if($wtmbanner{"et_$s"}>$wtmbanner{"ht_$s"}){if($wtmbanner{"ht_$s"}>$t && $wtmbanner{"et_$s"}<$t){next}}
		else{if($wtmbanner{"ht_$s"}<$t && $wtmbanner{"et_$s"}>$t){next}}
#    
		if($wtmbanner{"q_$s"}<=$wtmbanner{"qa_$s"}){next}
#   
		for(1..$wtmbanner{"p_$s"}){$s[$a]=$s;++$a}
	}
#   ,    
	if(!$a)
	{	for(@a)
		{	if(!/^bid_(.*)/){next}
			if(/^e/){last}
			$s=1;
#   
			if($wtmbanner{"d_$s"} ne 'on'){next}
#   
			if($wtmbanner{"hd_$s"}>$curtime || $wtmbanner{"ed_$s"}<$curtime){next}
#    
			$t=($t[2]*60+$t[1])*60+$t[0];
			if($wtmbanner{"et_$s"}>$wtmbanner{"ht_$s"}){if($wtmbanner{"ht_$s"}>$t && $wtmbanner{"et_$s"}<$t){next}}
			else{if($wtmbanner{"ht_$s"}<$t && $wtmbanner{"et_$s"}>$t){next}}
#    
			if($wtmbanner{"p_$s"}<=0){$wtmbanner{"p_$s"}=1}
#   
			for(1..$wtmbanner{"p_$s"}){$s[$a]=$s;++$a}
		}
	}
#    
	$s=rand($a);
	$banner_id=$s[$s];
	$s=$_[0];$s=~s/\$banner/$wtmbanner{"b_$banner_id"}/;
	return $s;
}

##  
sub savebanner
{	my(@c)=localtime(time+$inip{timeshift}*60);$c[5]+=1900;
	my($c)=sprintf('%2.2d:%2.2d:%2.2d %2.2d/%2.2d/%4d',$c[2],$c[1],$c[0],$c[3],$c[4]+1,$c[5]);
	if($inip{'wtmail_banner'} ne 'on'){return}

	if(!-e "$inip{realpath}/$inip{wtmail_bannerdir}/".$wtmbanner{"f_$banner_id"}.'.htm')
	{	open NAM,'>'.$inip{realpath}.'/'.$inip{'wtmail_bannerdir'}.'/'.$wtmbanner{"f_$banner_id"}.".htm";print NAM "<html><title>  $banner_id</title>\n<h2>  <i>(ID=$banner_id)</i></h2><p>: <b><pre><p>".$wtmbanner{"b_$banner_id"}."<p></pre></b><hr size=1><p>\n<b><i>   :</i></b><br><ol>\n";close NAM;
		open NAM,">>$inip{realpath}/$inip{wtmail_bannerdir}/index.htm";print NAM "ID=$banner_id, <a href=".$wtmbanner{"f_$banner_id"}.".htm></a><br>\n";close NAM;
	}
	++$wtmbanner{"qa_$banner_id"};
	open NAM,">>$inip{realpath}/$inip{'wtmail_bannerdir'}/".$wtmbanner{"f_$banner_id"}.".htm";print NAM "<li>\"$_[1]\" &lt;$_[0]&gt;, <i>$c</i><br>\n";close NAM;
	if(length$inip{'wtmail_errorfile'}){open NAM,">>$data/".$inip{'wtmail_errorfile'};print NAM "$c. Mail with $banner_id sent to $_[0], user $_[1], reason: $_[2]\n";close NAM;}
	dbmclose%wtmbanner;
}


##    
sub saveerror
{	my(@c)=localtime(time+$inip{timeshift}*60);$c[5]+=1900;
	my($c)=sprintf('%2.2d:%2.2d:%2.2d %2.2d/%2.2d/%4d',$c[2],$c[1],$c[0],$c[3],$c[4]+1,$c[5]);
	if(length$inip{'wtmail_errorfile'}){open NAM,">>$data/$inip{'wtmail_errorfile'}";print NAM "$c. Error send mail to $_[0], user $_[1], reason: $_[2]\n";close NAM;}
}

1;
